package net.sergeych.kiloparsec

import kotlinx.coroutines.flow.Flow
import kotlinx.coroutines.launch
import net.sergeych.crypto.Key
import net.sergeych.mp_tools.globalLaunch

@Suppress("unused")
class KiloServer<S>(
    private val clientInterface: KiloInterface<S>,
    private val connections: Flow<Transport.Device>,
    private val serverSigningKey: Key.Signing? = null,
    private val sessionBuilder: ()->S,
    ) {

    private val job = globalLaunch {
        connections.collect { device ->
            launch {
                KiloServerConnection(clientInterface,device,sessionBuilder(), serverSigningKey).run()
            }
        }
    }

    fun close() {
        job.cancel()
    }
}